Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/NormalDistributedRandomExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/NormalDistributedRandomExtensions.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/NormalDistributedRandomExtensions.cs	(revision 15289)
@@ -0,0 +1,11 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Extensions {
+  using System;
+
+  using HeuristicLab.Random;
+
+  public static class NormalDistributedRandomExtensions {
+    public static int NextRounded(this NormalDistributedRandom random) {
+      return (int)Math.Round(random.NextDouble(), 0);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj	(revision 15289)
@@ -124,4 +124,5 @@
     <Compile Include="Erc\String\StringErcOptions.cs" />
     <Compile Include="Extensions\EnumerableExtensions.cs" />
+    <Compile Include="Extensions\NormalDistributedRandomExtensions.cs" />
     <Compile Include="Generators\StringGenerator.cs" />
     <Compile Include="Weighted\IWeighted.cs" />
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15289)
@@ -228,15 +228,16 @@
     <Compile Include="Push\Problem\BenchmarkSuite\PlushPushBenchmarkSuiteProblem.cs" />
     <Compile Include="Push\Problem\PlushPushProblem.cs" />
-    <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteSolution.cs" />
+    <Compile Include="Push\Solution\IPushSolution.cs" />
+    <Compile Include="Push\Solution\BenchmarkSuite\PushBenchmarkSuiteSolution.cs" />
     <Compile Include="Push\Problem\DataBounds.cs" />
-    <Compile Include="Push\Problem\EvaluationResult.cs" />
+    <Compile Include="Push\Evaluator\EvaluationResult.cs" />
     <Compile Include="Push\Individual\IndividualExtensions.cs" />
-    <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteEvaluator.cs" />
+    <Compile Include="Push\Evaluator\PushBenchmarkSuiteEvaluator.cs" />
     <Compile Include="Push\Problem\BenchmarkSuite\IntegerVectorPushBenchmarkSuiteProblem.cs" />
-    <Compile Include="Push\Problem\IPushEvaluator.cs" />
+    <Compile Include="Push\Evaluator\IPushEvaluator.cs" />
     <Compile Include="Push\Problem\IntegerVectorPushProblem.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Push\Problem\PushProblemBase.cs" />
-    <Compile Include="Push\Problem\PushSolution.cs" />
+    <Compile Include="Push\Solution\PushSolution.cs" />
     <Compile Include="Push\Data\Pool\PooledObject.cs" />
     <Compile Include="Push\Selector\ICaseSingleObjectiveSelector.cs" />
@@ -266,8 +267,8 @@
       <DependentUpon>PushDebuggerView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Push\Problem\BenchmarkSuite\BenchmarkSuitePushSolutionView.cs">
+    <Compile Include="Push\Solution\BenchmarkSuite\BenchmarkSuitePushSolutionView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="Push\Problem\BenchmarkSuite\BenchmarkSuitePushSolutionView.Designer.cs">
+    <Compile Include="Push\Solution\BenchmarkSuite\BenchmarkSuitePushSolutionView.Designer.cs">
       <DependentUpon>BenchmarkSuitePushSolutionView.cs</DependentUpon>
     </Compile>
@@ -291,5 +292,5 @@
       <DependentUpon>PushDebuggerView.cs</DependentUpon>
     </EmbeddedResource>
-    <EmbeddedResource Include="Push\Problem\BenchmarkSuite\BenchmarkSuitePushSolutionView.resx">
+    <EmbeddedResource Include="Push\Solution\BenchmarkSuite\BenchmarkSuitePushSolutionView.resx">
       <DependentUpon>BenchmarkSuitePushSolutionView.cs</DependentUpon>
     </EmbeddedResource>
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs	(revision 15289)
@@ -19,10 +19,12 @@
     private const string RESULTS_PARAMETER_NAME = "Results";
     private const string INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME = "ZeroErrorIndividualsPerCase";
+    private const string INDIVIDUAL_ZERO_ERROR_HISTORY_PARAMETER_NAME = INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME + "History";
 
     private const string RESULT_PARAMETER_NAME = "Zero Error Individuals Per Case";
     private const string RESULT_PARAMETER_DESCRIPTION = "Relative frequency of instructions aggregated over the whole population.";
     private const string Y_AXIS_TITLE = "Count of zero error individuals";
-    private const string X_AXIS_TITLE = "Case Index";
+    private const string X_AXIS_TITLE = "Case Nr";
     private const string ROW_NAME = "Cases";
+    private const string HISTORY_TABLE_NAME = "Individual Zero Error history";
 
     public IndividualZeroErrorAnalyzer() {
@@ -31,4 +33,8 @@
         "The data table to store the count of individuals with zero error."));
 
+      Parameters.Add(new ValueLookupParameter<DataTableHistory>(
+        INDIVIDUAL_ZERO_ERROR_HISTORY_PARAMETER_NAME,
+        "The data table to store the history."));
+
       Parameters.Add(new LookupParameter<ResultCollection>(
         RESULTS_PARAMETER_NAME,
@@ -38,4 +44,24 @@
        IntegerVectorPushProblem.CaseQualitiesScopeParameterName,
        "The quality of every single training case for each individual."));
+
+      Parameters.Add(new ValueParameter<BoolValue>(
+        "StoreHistory",
+        "True if the history of the analysis should be stored.",
+        new BoolValue(false)));
+
+      Parameters.Add(new ValueParameter<IntValue>(
+        "UpdateInterval",
+        "The interval in which the analysis should be applied.",
+        new IntValue(1)));
+
+      Parameters.Add(new ValueParameter<IntValue>(
+        "UpdateCounter",
+        "The value which counts how many times the operator was called since the last update.",
+        new IntValue(0)));
+
+      IndividualZeroErrorParameter.Hidden = true;
+      IndividualZeroErrorHistoryParameter.Hidden = true;
+      ResultsParameter.Hidden = true;
+      UpdateCounterParameter.Hidden = true;
     }
 
@@ -51,4 +77,17 @@
     public bool EnabledByDefault { get { return true; } }
 
+    public ValueParameter<BoolValue> StoreHistoryParameter
+    {
+      get { return (ValueParameter<BoolValue>)Parameters["StoreHistory"]; }
+    }
+    public ValueParameter<IntValue> UpdateIntervalParameter
+    {
+      get { return (ValueParameter<IntValue>)Parameters["UpdateInterval"]; }
+    }
+    public ValueParameter<IntValue> UpdateCounterParameter
+    {
+      get { return (ValueParameter<IntValue>)Parameters["UpdateCounter"]; }
+    }
+
     public ILookupParameter<DataTable> IndividualZeroErrorParameter
     {
@@ -56,4 +95,9 @@
     }
 
+    public ValueLookupParameter<DataTableHistory> IndividualZeroErrorHistoryParameter
+    {
+      get { return (ValueLookupParameter<DataTableHistory>)Parameters[INDIVIDUAL_ZERO_ERROR_HISTORY_PARAMETER_NAME]; }
+    }
+
     public ILookupParameter<ResultCollection> ResultsParameter
     {
@@ -67,4 +111,11 @@
 
     public override IOperation Apply() {
+      UpdateCounterParameter.Value.Value++;
+      // the analyzer runs periodically, every 'updateInterval' times
+      if (UpdateCounterParameter.Value.Value != UpdateIntervalParameter.Value.Value)
+        return base.Apply();
+
+      UpdateCounterParameter.Value.Value = 0; // reset counter
+
       var caseQualitiesPerIndividual = CaseQualitiesParameter.ActualValue;
       var caseCount = caseQualitiesPerIndividual[0].Length;
@@ -80,5 +131,9 @@
             YAxisTitle = Y_AXIS_TITLE,
             XAxisTitle = X_AXIS_TITLE,
-            XAxisMinimumFixedValue = 0,
+            YAxisMinimumFixedValue = 0,
+            YAxisMaximumFixedValue = 1,
+            YAxisMinimumAuto = false,
+            SecondYAxisMaximumAuto = false,
+            XAxisMinimumFixedValue = 1,
             XAxisMaximumFixedValue = caseCount,
             XAxisMaximumAuto = false,
@@ -100,5 +155,5 @@
               StartIndexZero = true,
               IsVisibleInLegend = false,
-              ChartType = DataRowVisualProperties.DataRowChartType.Bars,
+              ChartType = DataRowVisualProperties.DataRowChartType.Columns,
             }
         };
@@ -107,10 +162,5 @@
       }
 
-      var caseCountChanged = row.Values.Count != caseCount;
-
-      if (caseCountChanged) {
-        individualZeroErrorCounts.VisualProperties.XAxisMaximumFixedValue = caseCount;
-        row.Values.Clear();
-      }
+      row.Values.Clear();
 
       for (var i = 0; i < caseCount; i++) {
@@ -124,8 +174,26 @@
         }
 
-        if (caseCountChanged)
-          row.Values.Add(count);
-        else
-          row.Values[i] = count;
+        var relativeCount = count / (double)caseQualitiesPerIndividual.Length;
+
+        row.Values.Add(relativeCount);
+      }
+
+      var storeHistory = StoreHistoryParameter.Value.Value;
+
+      if (storeHistory) {
+        var history = IndividualZeroErrorHistoryParameter.ActualValue;
+
+        if (history == null) {
+          history = new DataTableHistory();
+          IndividualZeroErrorHistoryParameter.ActualValue = history;
+        }
+
+        history.Add((DataTable)individualZeroErrorCounts.Clone());
+
+        if (!results.ContainsKey(HISTORY_TABLE_NAME)) {
+          results.Add(new Result(HISTORY_TABLE_NAME, history));
+        } else {
+          results[HISTORY_TABLE_NAME].Value = history;
+        }
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorDistributionAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorDistributionAnalyzer.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorDistributionAnalyzer.cs	(revision 15289)
@@ -20,9 +20,11 @@
     private const string RESULTS_PARAMETER_NAME = "Results";
     private const string INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME = "ZeroErrorIndividualsPerCaseDistribution";
+    private const string INDIVIDUAL_ZERO_ERROR_HISTORY_PARAMETER_NAME = "ZeroErrorIndividualsPerCaseDistributionHistory";
 
+    private const string HISTORY_TABLE_NAME = "Individual Zero Error Distribution History";
     private const string RESULT_PARAMETER_NAME = "Zero Error Individual Per Case Distribution";
     private const string RESULT_PARAMETER_DESCRIPTION = "Relative frequency of instructions aggregated over the whole population.";
     private const string Y_AXIS_TITLE = "Number of zero error cases";
-    private const string X_AXIS_TITLE = "Number of individuals";
+    private const string X_AXIS_TITLE = "Individuals Nr";
     private const string ROW_NAME = "Cases";
 
@@ -31,4 +33,8 @@
         INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME,
         "The data table to store the count of individuals with zero error."));
+
+      Parameters.Add(new ValueLookupParameter<DataTableHistory>(
+        INDIVIDUAL_ZERO_ERROR_HISTORY_PARAMETER_NAME,
+        "The data table to store the history."));
 
       Parameters.Add(new LookupParameter<ResultCollection>(
@@ -39,7 +45,27 @@
        IntegerVectorPushProblem.CaseQualitiesScopeParameterName,
        "The quality of every single training case for each individual."));
+
+      Parameters.Add(new ValueParameter<BoolValue>(
+        "StoreHistory",
+        "True if the history of the analysis should be stored.",
+        new BoolValue(false)));
+
+      Parameters.Add(new ValueParameter<IntValue>(
+        "UpdateInterval",
+        "The interval in which the analysis should be applied.",
+        new IntValue(1)));
+
+      Parameters.Add(new ValueParameter<IntValue>(
+        "UpdateCounter",
+        "The value which counts how many times the operator was called since the last update.",
+        new IntValue(0)));
+
+      IndividualZeroErrorDistributionParameter.Hidden = true;
+      IndividualZeroErrorDistributionHistoryParameter.Hidden = true;
+      ResultsParameter.Hidden = true;
+      UpdateCounterParameter.Hidden = true;
     }
 
-    [StorableConstructorAttribute]
+    [StorableConstructor]
     public IndividualZeroErrorDistributionAnalyzer(bool deserializing) : base(deserializing) { }
 
@@ -52,7 +78,25 @@
     public bool EnabledByDefault { get { return true; } }
 
+    public ValueParameter<BoolValue> StoreHistoryParameter
+    {
+      get { return (ValueParameter<BoolValue>)Parameters["StoreHistory"]; }
+    }
+    public ValueParameter<IntValue> UpdateIntervalParameter
+    {
+      get { return (ValueParameter<IntValue>)Parameters["UpdateInterval"]; }
+    }
+    public ValueParameter<IntValue> UpdateCounterParameter
+    {
+      get { return (ValueParameter<IntValue>)Parameters["UpdateCounter"]; }
+    }
+
     public ILookupParameter<DataTable> IndividualZeroErrorDistributionParameter
     {
       get { return (ILookupParameter<DataTable>)Parameters[INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME]; }
+    }
+
+    public ValueLookupParameter<DataTableHistory> IndividualZeroErrorDistributionHistoryParameter
+    {
+      get { return (ValueLookupParameter<DataTableHistory>)Parameters[INDIVIDUAL_ZERO_ERROR_HISTORY_PARAMETER_NAME]; }
     }
 
@@ -68,4 +112,11 @@
 
     public override IOperation Apply() {
+      UpdateCounterParameter.Value.Value++;
+      // the analyzer runs periodically, every 'updateInterval' times
+      if (UpdateCounterParameter.Value.Value != UpdateIntervalParameter.Value.Value)
+        return base.Apply();
+
+      UpdateCounterParameter.Value.Value = 0; // reset counter
+
       var caseQualitiesPerIndividual = CaseQualitiesParameter.ActualValue;
       var individualCount = caseQualitiesPerIndividual.Length;
@@ -82,6 +133,11 @@
             YAxisTitle = Y_AXIS_TITLE,
             XAxisTitle = X_AXIS_TITLE,
-            XAxisMinimumFixedValue = 0,
-            XAxisMaximumAuto = true,
+            YAxisMaximumFixedValue = 1,
+            YAxisMinimumFixedValue = 0,
+            YAxisMaximumAuto = false,
+            YAxisMinimumAuto = false,
+            XAxisMinimumFixedValue = 1,
+            XAxisMaximumFixedValue = individualCount,
+            XAxisMaximumAuto = false,
             XAxisMinimumAuto = false,
           }
@@ -101,5 +157,5 @@
               StartIndexZero = true,
               IsVisibleInLegend = false,
-              ChartType = DataRowVisualProperties.DataRowChartType.Histogram,
+              ChartType = DataRowVisualProperties.DataRowChartType.Columns,
             }
         };
@@ -108,26 +164,30 @@
       }
 
-      var caseCountChanged = row.Values.Count != caseCount;
+      row.Values.Clear();
 
-      if (caseCountChanged) {
-        row.Values.Clear();
+      for (var i = 0; i < caseQualitiesPerIndividual.Length; i++) {
+        var count = caseQualitiesPerIndividual[i].Count(q => q == 0.0);
+        var ratio = count / (double)caseCount;
+
+        row.Values.Add(ratio);
       }
 
-      // key represents the number of cases with zero error
-      // value represents the number of individuals with key cases with zero error
-      var distribution = caseQualitiesPerIndividual
-              .Select(individual => individual.Count(x => x == 0.0))
-              .GroupBy(x => x)
-              .ToDictionary(x => x.Key, x => x.Count());
+      var storeHistory = StoreHistoryParameter.Value.Value;
 
-      for (var i = 0; i < caseCount; i++) {
-        int count;
-        distribution.TryGetValue(i, out count);
-        var x = count / (double)individualCount;
+      if (storeHistory) {
+        var history = IndividualZeroErrorDistributionHistoryParameter.ActualValue;
 
-        if (caseCountChanged)
-          row.Values.Add(x);
-        else
-          row.Values[i] = x;
+        if (history == null) {
+          history = new DataTableHistory();
+          IndividualZeroErrorDistributionHistoryParameter.ActualValue = history;
+        }
+
+        history.Add((DataTable)individualZeroErrorDistribution.Clone());
+
+        if (!results.ContainsKey(HISTORY_TABLE_NAME)) {
+          results.Add(new Result(HISTORY_TABLE_NAME, history));
+        } else {
+          results[HISTORY_TABLE_NAME].Value = history;
+        }
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs	(revision 15289)
@@ -1,4 +1,5 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer {
   using System;
+  using System.Collections.Generic;
   using System.Linq;
 
@@ -14,7 +15,7 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Individual;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.ObjectPools.Random;
 
   /// <summary>
@@ -24,5 +25,4 @@
   [StorableClass]
   public class PushExpressionFrequencyAnalyzer : SingleSuccessorOperator, IPushExpressionAnalyzer {
-    private readonly SeededRandomPool randomPool = new SeededRandomPool();
 
     private const string PUSH_CONFIGURATION_PARAMETER_NAME = "PushConfiguration";
@@ -40,4 +40,5 @@
       Parameters.Add(new LookupParameter<IReadOnlyPushConfiguration>(PUSH_CONFIGURATION_PARAMETER_NAME, "The current specified push configuration."));
       Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>(INTEGER_VECTOR_PARAMETER_NAME, "The integer vectors to analyze."));
+      Parameters.Add(new ScopeTreeLookupParameter<PlushVector>("Plush", "The plush vectors to analyze."));
       Parameters.Add(new LookupParameter<DataTable>(EXPRESSION_FREQUENCIES_PARAMETER_NAME, "The data table to store the instruction frequencies."));
       Parameters.Add(new LookupParameter<ResultCollection>(RESULTS_PARAMETER_NAME, "The result collection where the symbol frequencies should be stored."));
@@ -60,4 +61,9 @@
     {
       get { return (ILookupParameter<IReadOnlyPushConfiguration>)Parameters[PUSH_CONFIGURATION_PARAMETER_NAME]; }
+    }
+
+    public IScopeTreeLookupParameter<PlushVector> PlushVectorParameter
+    {
+      get { return (IScopeTreeLookupParameter<PlushVector>)Parameters["Plush"]; }
     }
 
@@ -95,15 +101,15 @@
     public override IOperation Apply() {
       var config = PushConfigurationParameter.ActualValue;
-      var integerVectors = IntegerVectorParameter.ActualValue;
 
-      randomPool.Seed = config.Seed;
+      IReadOnlyList<PushProgram> pushPrograms = null;
 
-      var pushPrograms = integerVectors.Select(iv => {
-        var random = randomPool.ResetAndAllocate();
-        var program = iv.ToPushProgram(config, random);
-        randomPool.Free(random);
-
-        return program;
-      });
+      if (IntegerVectorParameter.ActualValue.Length > 0) {
+        pushPrograms = IntegerVectorParameter.ActualValue.Select(iv => iv.ToPushProgram(config)).ToList();
+      } else if (PlushVectorParameter.ActualValue.Length > 0) {
+        pushPrograms = PlushVectorParameter.ActualValue.Select(pv => pv.PushProgram).ToList();
+      } else {
+        // nothing to do
+        return base.Apply();
+      }
 
       var results = ResultsParameter.ActualValue;
@@ -136,5 +142,5 @@
           group => group.Count());
 
-      var totalNumberofExpressions = Math.Max(1.0, expressionFrequencies.Values.Sum());
+      var totalNumberOfExpressions = Math.Max(1.0, expressionFrequencies.Values.Sum());
 
       // all rows must have the same number of values so we can just take the first
@@ -152,5 +158,5 @@
         }
 
-        frequencies.Rows[pair.Key].Values.Add(Math.Round(pair.Value / totalNumberofExpressions, 3));
+        frequencies.Rows[pair.Key].Values.Add(Math.Round(pair.Value / totalNumberOfExpressions, 3));
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15289)
@@ -1,4 +1,3 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
-  using System.Collections.Generic;
   using Base.Erc;
 
@@ -6,5 +5,4 @@
 
   public interface IReadOnlyPushConfiguration : IReadOnlyExpressionsConfiguration {
-    int Seed { get; }
     int EvalPushLimit { get; }
     int MaxDepth { get; }
@@ -18,5 +16,4 @@
     double ParenthesesCloseBiasLevel { get; }
     IReadOnlyErcOptions ErcOptions { get; }
-    IReadOnlyList<string> EnabledExpressions { get; }
     string FloatStringFormat { get; }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15289)
@@ -52,5 +52,5 @@
 
 
-    IReadOnlyList<string> IReadOnlyPushConfiguration.EnabledExpressions { get { return enabledExpressions; } }
+    IReadOnlyList<string> IReadOnlyExpressionsConfiguration.EnabledExpressions { get { return enabledExpressions; } }
 
     [Storable]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15289)
@@ -154,5 +154,5 @@
     }
 
-    IReadOnlyList<string> IReadOnlyPushConfiguration.EnabledExpressions
+    IReadOnlyList<string> IReadOnlyExpressionsConfiguration.EnabledExpressions
     {
       get
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/PushEnvironment.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/PushEnvironment.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/PushEnvironment.cs	(revision 15289)
@@ -17,5 +17,6 @@
     public const string CharSymbolStr = "'";
     public const string StringSymbolStr = "\"";
-    public const string NewLine = "\n";
+    public const char NewLine = '\n';
+    public const string NewLineStr = "\n";
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Crossover/AlternationCrossover.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Crossover/AlternationCrossover.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Crossover/AlternationCrossover.cs	(revision 15289)
@@ -10,4 +10,5 @@
   using HeuristicLab.Parameters;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
   using HeuristicLab.Random;
@@ -23,8 +24,11 @@
     public AlternationCrossover() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic crossover operators."));
+
       Parameters.Add(new ScopeTreeLookupParameter<PlushVector>("Parents", "The parent vectors which should be crossed."));
       ParentsParameter.ActualName = "PlushVector";
+
       Parameters.Add(new LookupParameter<PlushVector>("Child", "The child vector resulting from the crossover."));
       ChildParameter.ActualName = "PlushVector";
+
       Parameters.Add(new FixedValueParameter<PercentValue>("AlternationRate", "Specifies the probability of switching to another parent.", new PercentValue(0.5)));
       Parameters.Add(new FixedValueParameter<DoubleValue>("AlignmentDeviation", "When alternating between parents, the index at which to continue copying may be offset backward or forward some amount based on a random sample from a normal distribution with mean 0 and standard deviation set by the alignment deviation parameter", new DoubleValue(1.0)));
@@ -90,15 +94,24 @@
 
     public sealed override IOperation InstrumentedApply() {
-      ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
+      ChildParameter.ActualValue = Cross(
+        RandomParameter.ActualValue,
+        ParentsParameter.ActualValue,
+        AlternationRate,
+        MaxLength,
+        AlignmentDeviation);
       return base.InstrumentedApply();
     }
 
-    private PlushVector Cross(IRandom random, ItemArray<PlushVector> parents) {
-      var normalDistributedRandom = new NormalDistributedRandom(random, Mean, AlignmentDeviation);
+    private static PlushVector Cross(
+      IRandom random,
+      ItemArray<PlushVector> parents,
+      double alternationRate,
+      int maxChildLength,
+      double alignmentDeviation) {
+      var normalDistributedRandom = new NormalDistributedRandom(random, Mean, alignmentDeviation);
       var maxLength = parents.Max(p => p.Entries.Count);
       var parentIndex = random.Next(0, 2);
       var parent = parents[parentIndex];
       var child = new PlushVector(maxLength);
-      var maxChildLength = MaxLength;
 
       for (var i = 0; i < maxLength && child.Entries.Count <= maxChildLength; i++) {
@@ -109,8 +122,8 @@
 
         // switch parent?
-        if (random.NextDouble() < AlternationRate) {
+        if (random.NextDouble() < alternationRate) {
           parentIndex = parentIndex == 0 ? 1 : 0;
           parent = parents[parentIndex];
-          i += normalDistributedRandom.Next();
+          i += normalDistributedRandom.NextRounded();
           i = Math.Max(i, 0);
         }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs	(revision 15289)
@@ -34,4 +34,9 @@
       inInstructionProbabilityParameter = new FixedValueParameter<PercentValue>(Name + ".InInstructionProbability");
 
+      Parameters.Add(minLengthParameter);
+      Parameters.Add(maxLengthParameter);
+      Parameters.Add(minCloseParameter);
+      Parameters.Add(maxCloseParameter);
+      Parameters.Add(closeBiasLevelParameter);
       Parameters.Add(instructionsParameter);
       Parameters.Add(ercOptionsParameter);
@@ -371,4 +376,5 @@
         creator.MinCloseParameter.ActualName = MinCloseParameter.Name;
         creator.MaxCloseParameter.ActualName = MinCloseParameter.Name;
+        creator.CloseBiasLevelParameter.ActualName = CloseBiasLevelParameter.Name;
         creator.ErcOptionsParameter.ActualName = ErcOptionsParameter.Name;
         creator.InstructionsParameter.ActualName = InstructionsParameter.Name;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs	(revision 15289)
@@ -26,4 +26,6 @@
 
     public PlushVector(PlushVector origin, Cloner cloner) : base(origin, cloner) {
+      entries = new List<PlushEntry>(origin.entries);
+      pushProgram = origin.pushProgram;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/EvaluationResult.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/EvaluationResult.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/EvaluationResult.cs	(revision 15289)
@@ -0,0 +1,11 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator {
+  public class EvaluationResult {
+    public EvaluationResult(int exampleCount) {
+      ExampleQualities = new double[exampleCount];
+    }
+
+
+    public double AvgQuality { get; set; }
+    public double[] ExampleQualities { get; set; }
+  }
+}
